diff --git a/ui/app/views/popup.ldap.edit.php b/ui/app/views/popup.ldap.edit.php
new file mode 100644
index 00000000000..51b85ad6c30
--- /dev/null
+++ b/ui/app/views/popup.ldap.edit.php
@@ -0,0 +1,190 @@
+<?php declare(strict_types = 1);
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+
+/**
+ * @var CView $this
+ * @var array $data
+ */
+
+$form_action = (new CUrl('zabbix.php'))
+	->setArgument('action', 'popup.ldap.check')
+	->getUrl();
+
+$form = (new CForm('post', $form_action))
+	->addItem(getMessages())
+	->addItem((new CInput('submit'))->addStyle('display: none;'))
+	->addVar('row_index', $data['row_index'])
+	->addVar('userdirectoryid', $data['userdirectoryid'] ?? null)
+	->addItem((new CFormGrid())
+		->addItem([
+			(new CLabel(_('Name'), 'name'))->setAsteriskMark(),
+			new CFormField(
+				(new CTextBox('name', $data['name'], false, DB::getFieldLength('userdirectory', 'name')))
+					->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
+					->setAriaRequired()
+					->setAttribute('autofocus', 'autofocus')
+			)
+		])
+		->addItem([
+			(new CLabel(_('Host'), 'host'))->setAsteriskMark(),
+			new CFormField(
+				(new CTextBox('host', $data['host'], false, DB::getFieldLength('userdirectory', 'host')))
+					->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
+					->setAriaRequired()
+			)
+		])
+		->addItem([
+			(new CLabel(_('Port'), 'port'))->setAsteriskMark(),
+			new CFormField(
+				(new CNumericBox('port', $data['port'], 5))
+					->setWidth(ZBX_TEXTAREA_NUMERIC_STANDARD_WIDTH)
+					->setAriaRequired()
+			)
+		])
+		->addItem([
+			(new CLabel(_('Base DN'), 'base_dn'))->setAsteriskMark(),
+			new CFormField(
+				(new CTextBox('base_dn', $data['base_dn'], false, DB::getFieldLength('userdirectory', 'base_dn')))
+					->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
+					->setAriaRequired()
+			)
+		])
+		->addItem([
+			(new CLabel(_('Search attribute'), 'search_attribute'))->setAsteriskMark(),
+			new CFormField(
+				(new CTextBox('search_attribute', $data['search_attribute'], false,
+					DB::getFieldLength('userdirectory', 'search_attribute')
+				))
+					->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
+					->setAriaRequired()
+			)
+		])
+		->addItem([
+			new CLabel(_('Bind DN'), 'bind_dn'),
+			new CFormField(
+				(new CTextBox('bind_dn', $data['bind_dn'], false, DB::getFieldLength('userdirectory', 'bind_dn')))
+					->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
+			)
+		])
+		->addItem([
+			new CLabel(_('Bind password'), 'bind_password'),
+			new CFormField($data['add_ldap_server'] == 0
+				? [
+					array_key_exists('bind_password', $data)
+						? new CVar('bind_password', $data['bind_password'])
+						: null,
+					(new CSimpleButton(_('Change password')))
+						->addClass(ZBX_STYLE_BTN_GREY)
+						->setId('bind-password-btn'),
+					(new CPassBox('bind_password', '', DB::getFieldLength('userdirectory', 'bind_password')))
+						->setWidth(ZBX_TEXTAREA_SMALL_WIDTH)
+						->addStyle('display: none;')
+						->setAttribute('disabled', 'disabled')
+				]
+				: (new CPassBox('bind_password', '', DB::getFieldLength('userdirectory', 'bind_password')))
+					->setWidth(ZBX_TEXTAREA_SMALL_WIDTH)
+			)
+		])
+		->addItem([
+			new CLabel(_('Description'), 'description'),
+			new CFormField(
+				(new CTextArea('description', $data['description'], ['rows' => 3]))
+					->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
+					->setMaxlength(DB::getFieldLength('userdirectory', 'description'))
+			)
+		])
+		->addItem([
+			new CLabel(_('Advanced configuration'), 'advanced_configuration'),
+			new CFormField(
+				(new CCheckBox('advanced_configuration'))->setChecked($data['advanced_configuration'])
+			)
+		])
+		->addItem([
+			(new CLabel(_('StartTLS'), 'start_tls'))->addClass('advanced-configuration'),
+			(new CFormField(
+				(new CCheckBox('start_tls', ZBX_AUTH_START_TLS_ON))
+					->setChecked($data['start_tls'] == ZBX_AUTH_START_TLS_ON)
+			))->addClass('advanced-configuration')
+		])
+		->addItem([
+			(new CLabel(_('Search filter'), 'search_filter'))->addClass('advanced-configuration'),
+			(new CFormField(
+				(new CTextBox('search_filter', $data['search_filter'], false,
+					DB::getFieldLength('userdirectory', 'search_filter')
+				))
+					->setAttribute('placeholder', '(%{attr}=%{user})')
+					->setWidth(ZBX_TEXTAREA_STANDARD_WIDTH)
+			))->addClass('advanced-configuration')
+		])
+	)
+	->addItem(
+		(new CScriptTag('
+			ldap_edit_popup.init();
+		'))->setOnDocumentReady()
+	);
+
+if ($data['add_ldap_server']) {
+	$title = _('New LDAP server');
+	$buttons = [
+		[
+			'title' => _('Add'),
+			'class' => 'js-add',
+			'keepOpen' => true,
+			'isSubmit' => true,
+			'action' => 'ldap_edit_popup.submit();'
+		]
+	];
+}
+else {
+	$title = _('LDAP Server');
+	$buttons = [
+		[
+			'title' => _('Update'),
+			'class' => 'js-update',
+			'keepOpen' => true,
+			'isSubmit' => true,
+			'action' => 'ldap_edit_popup.submit();'
+		]
+	];
+}
+
+$buttons[] = [
+	'title' => _('Test'),
+	'class' => implode(' ', [ZBX_STYLE_BTN_ALT, 'js-test']),
+	'keepOpen' => true,
+	'isSubmit' => false,
+	'action' => 'ldap_edit_popup.openTestPopup();'
+];
+
+$output = [
+	'header' => $title,
+	'body' => $form->toString(),
+	'buttons' => $buttons,
+	'script_inline' => getPagePostJs().
+		$this->readJsFile('popup.ldap.edit.js.php')
+];
+
+if ($data['user']['debug_mode'] == GROUP_DEBUG_MODE_ENABLED) {
+	CProfiler::getInstance()->stop();
+	$output['debug'] = CProfiler::getInstance()->make()->toString();
+}
+
+echo json_encode($output);
diff --git a/ui/app/views/popup.ldap.test.edit.php b/ui/app/views/popup.ldap.test.edit.php
new file mode 100644
index 00000000000..efbbdb39822
--- /dev/null
+++ b/ui/app/views/popup.ldap.test.edit.php
@@ -0,0 +1,78 @@
+<?php declare(strict_types = 1);
+/*
+** Zabbix
+** Copyright (C) 2001-2022 Zabbix SIA
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License as published by
+** the Free Software Foundation; either version 2 of the License, or
+** (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+**/
+
+
+/**
+ * @var CView $this
+ * @var array $data
+ */
+
+$form_action = (new CUrl('zabbix.php'))
+	->setArgument('action', 'popup.ldap.test.send')
+	->getUrl();
+
+$form = (new CForm('post', $form_action))
+	->addItem((new CInput('submit'))->addStyle('display: none;'))
+	->addItem((new CFormGrid())
+		->addItem([
+			(new CLabel(_('Login'), 'test_username'))->setAsteriskMark(),
+			new CFormField(
+				(new CTextBox('test_username', $data['test_username']))
+					->setWidth(ZBX_TEXTAREA_SMALL_WIDTH)
+					->setAriaRequired()
+			)
+		])
+		->addItem([
+			(new CLabel(_('User password'), 'test_password'))->setAsteriskMark(),
+			new CFormField(
+				(new CPassBox('test_password'))
+					->setWidth(ZBX_TEXTAREA_SMALL_WIDTH)
+					->setAriaRequired()
+			)
+		])
+	)
+	->addItem(
+		(new CScriptTag('ldap_test_edit_popup.init();'))->setOnDocumentReady()
+	);
+
+foreach ($data['ldap_config'] as $field => $value) {
+	$form->addVar($field, $value);
+}
+
+$output = [
+	'header' => _('Test authentication'),
+	'body' => $form->toString(),
+	'buttons' => [
+		[
+			'title' => _('Test'),
+			'keepOpen' => true,
+			'isSubmit' => true,
+			'action' => 'ldap_test_edit_popup.submit();'
+		]
+	],
+	'script_inline' => $this->readJsFile('popup.ldap.test.edit.js.php')
+];
+
+if ($data['user']['debug_mode'] == GROUP_DEBUG_MODE_ENABLED) {
+	CProfiler::getInstance()->stop();
+	$output['debug'] = CProfiler::getInstance()->make()->toString();
+}
+
+echo json_encode($output);
diff --git a/ui/include/classes/api/API.php b/ui/include/classes/api/API.php
index 6813e152f88..23bec67d17a 100644
--- a/ui/include/classes/api/API.php
+++ b/ui/include/classes/api/API.php
@@ -444,6 +444,13 @@ class API {
 		return self::getApi('user');
 	}
 
+	/**
+	 * @return CUserDirectory
+	 */
+	public static function UserDirectory() {
+		return self::getApi('userdirectory');
+	}
+
 	/**
 	 * @return CUserGroup
 	 */
diff --git a/ui/include/classes/api/CApiServiceFactory.php b/ui/include/classes/api/CApiServiceFactory.php
index 00d8c34263f..31286652cc9 100644
--- a/ui/include/classes/api/CApiServiceFactory.php
+++ b/ui/include/classes/api/CApiServiceFactory.php
@@ -76,6 +76,7 @@ class CApiServiceFactory extends CRegistryFactory {
 		'trigger' => CTrigger::class,
 		'triggerprototype' => CTriggerPrototype::class,
 		'user' => CUser::class,
+		'userdirectory' => CUserDirectory::class,
 		'usergroup' => CUserGroup::class,
 		'usermacro' => CUserMacro::class,
 		'valuemap' => CValueMap::class
diff --git a/ui/include/classes/api/CAudit.php b/ui/include/classes/api/CAudit.php
index e79ac8581ac..f1d7f3b500f 100644
--- a/ui/include/classes/api/CAudit.php
+++ b/ui/include/classes/api/CAudit.php
@@ -82,6 +82,7 @@ class CAudit {
 	public const RESOURCE_SCHEDULED_REPORT = 46;
 	public const RESOURCE_HA_NODE = 47;
 	public const RESOURCE_SLA = 48;
+	public const RESOURCE_USERDIRECTORY = 49;
 
 	/**
 	 * Audit details actions.
@@ -133,6 +134,7 @@ class CAudit {
 		self::RESOURCE_TEMPLATE => 'hosts',
 		self::RESOURCE_TEMPLATE_DASHBOARD => 'dashboard',
 		self::RESOURCE_USER => 'users',
+		self::RESOURCE_USERDIRECTORY => 'userdirectory',
 		self::RESOURCE_USER_GROUP => 'usrgrp'
 	];
 
@@ -181,6 +183,7 @@ class CAudit {
 		self::RESOURCE_TEMPLATE => 'host',
 		self::RESOURCE_TEMPLATE_DASHBOARD => 'name',
 		self::RESOURCE_USER => 'username',
+		self::RESOURCE_USERDIRECTORY => 'name',
 		self::RESOURCE_USER_GROUP => 'name'
 	];
 
@@ -218,6 +221,7 @@ class CAudit {
 		self::RESOURCE_TEMPLATE => 'template',
 		self::RESOURCE_TEMPLATE_DASHBOARD => 'templatedashboard',
 		self::RESOURCE_USER => 'user',
+		self::RESOURCE_USERDIRECTORY => 'userdirectory',
 		self::RESOURCE_USER_GROUP => 'usergroup'
 	];
 
@@ -247,7 +251,8 @@ class CAudit {
 			'paths' => ['template.macros.value'],
 			'conditions' => ['type' => ZBX_MACRO_TYPE_SECRET]
 		],
-		self::RESOURCE_USER => ['paths' => ['user.passwd']]
+		self::RESOURCE_USER => ['paths' => ['user.passwd']],
+		self::RESOURCE_USERDIRECTORY => ['paths' => ['userdirectory.bind_dn', 'userdirectory.bind_password']]
 	];
 
 	/**
diff --git a/ui/include/classes/api/services/CAuditLog.php b/ui/include/classes/api/services/CAuditLog.php
index e809b05eb18..ee0085982fb 100644
--- a/ui/include/classes/api/services/CAuditLog.php
+++ b/ui/include/classes/api/services/CAuditLog.php
@@ -92,7 +92,8 @@ class CAuditLog extends CApiService {
 			CAudit::RESOURCE_SCHEDULED_REPORT, CAudit::RESOURCE_SCRIPT, CAudit::RESOURCE_SETTINGS, CAudit::RESOURCE_SLA,
 			CAudit::RESOURCE_TEMPLATE, CAudit::RESOURCE_TEMPLATE_DASHBOARD, CAudit::RESOURCE_TRIGGER,
 			CAudit::RESOURCE_TRIGGER_PROTOTYPE, CAudit::RESOURCE_USER, CAudit::RESOURCE_USER_GROUP,
-			CAudit::RESOURCE_USER_ROLE, CAudit::RESOURCE_VALUE_MAP, CAudit::RESOURCE_HA_NODE
+			CAudit::RESOURCE_USER_ROLE, CAudit::RESOURCE_VALUE_MAP, CAudit::RESOURCE_HA_NODE,
+			CAudit::RESOURCE_USERDIRECTORY
 		];
 
 		$api_input_rules = ['type' => API_OBJECT, 'fields' => [
diff --git a/ui/include/classes/api/services/CAuthentication.php b/ui/include/classes/api/services/CAuthentication.php
index ca1100d5de0..56cda2ce5ba 100644
--- a/ui/include/classes/api/services/CAuthentication.php
+++ b/ui/include/classes/api/services/CAuthentication.php
@@ -36,12 +36,11 @@ class CAuthentication extends CApiService {
 	 * @var array
 	 */
 	private $output_fields = ['authentication_type', 'http_auth_enabled', 'http_login_form', 'http_strip_domains',
-		'http_case_sensitive', 'ldap_configured', 'ldap_host', 'ldap_port', 'ldap_base_dn', 'ldap_search_attribute',
-		'ldap_bind_dn', 'ldap_case_sensitive', 'ldap_bind_password', 'saml_auth_enabled', 'saml_idp_entityid',
-		'saml_sso_url', 'saml_slo_url', 'saml_username_attribute', 'saml_sp_entityid', 'saml_nameid_format',
-		'saml_sign_messages', 'saml_sign_assertions', 'saml_sign_authn_requests', 'saml_sign_logout_requests',
-		'saml_sign_logout_responses', 'saml_encrypt_nameid', 'saml_encrypt_assertions', 'saml_case_sensitive',
-		'passwd_min_length', 'passwd_check_rules'
+		'http_case_sensitive', 'ldap_configured', 'ldap_case_sensitive', 'ldap_userdirectoryid', 'saml_auth_enabled',
+		'saml_idp_entityid', 'saml_sso_url', 'saml_slo_url', 'saml_username_attribute', 'saml_sp_entityid',
+		'saml_nameid_format', 'saml_sign_messages', 'saml_sign_assertions', 'saml_sign_authn_requests',
+		'saml_sign_logout_requests', 'saml_sign_logout_responses', 'saml_encrypt_nameid', 'saml_encrypt_assertions',
+		'saml_case_sensitive', 'passwd_min_length', 'passwd_check_rules'
 	];
 
 	/**
@@ -122,13 +121,8 @@ class CAuthentication extends CApiService {
 			'http_strip_domains' =>			['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('config', 'http_strip_domains')],
 			'http_case_sensitive' =>		['type' => API_INT32, 'in' => ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE],
 			'ldap_configured' =>			['type' => API_INT32, 'in' => ZBX_AUTH_LDAP_DISABLED.','.ZBX_AUTH_LDAP_ENABLED],
-			'ldap_host' =>					['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('config', 'ldap_host')],
-			'ldap_port' =>					['type' => API_INT32, 'in' => '0:65535'],
-			'ldap_base_dn' =>				['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('config', 'ldap_base_dn')],
-			'ldap_search_attribute' =>		['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('config', 'ldap_search_attribute')],
-			'ldap_bind_dn' =>				['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('config', 'ldap_bind_dn')],
 			'ldap_case_sensitive' =>		['type' => API_INT32, 'in' => ZBX_AUTH_CASE_INSENSITIVE.','.ZBX_AUTH_CASE_SENSITIVE],
-			'ldap_bind_password' =>			['type' => API_STRING_UTF8, 'length' => DB::getFieldLength('config', 'ldap_bind_password')],
+			'ldap_userdirectoryid' =>		['type' => API_ID, 'flags' => API_ALLOW_NULL],
 			'saml_auth_enabled' =>			['type' => API_INT32, 'in' => ZBX_AUTH_SAML_DISABLED.','.ZBX_AUTH_SAML_ENABLED],
 			'saml_idp_entityid' =>			['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('config', 'saml_idp_entityid')],
 			'saml_sso_url' =>				['type' => API_STRING_UTF8, 'flags' => API_NOT_EMPTY, 'length' => DB::getFieldLength('config', 'saml_sso_url')],
@@ -152,9 +146,42 @@ class CAuthentication extends CApiService {
 			self::exception(ZBX_API_ERROR_PARAMETERS, $error);
 		}
 
+		if (array_key_exists('ldap_userdirectoryid', $auth) && $auth['ldap_userdirectoryid']) {
+			$exists = API::UserDirectory()->get(['userdirectoryids' => $auth['ldap_userdirectoryid']]);
+
+			if (!$exists) {
+				static::exception(ZBX_API_ERROR_PARAMETERS,
+					_s('Invalid parameter "%1$s": %2$s.', '/ldap_userdirectoryid', _('referred object does not exist'))
+				);
+			}
+		}
+
 		$output_fields = $this->output_fields;
 		$output_fields[] = 'configid';
 
-		return DB::select('config', ['output' => $output_fields])[0];
+		$db_auth = DB::select('config', ['output' => $output_fields]);
+		$db_auth = reset($db_auth);
+
+		if (array_key_exists('authentication_type', $auth)) {
+			$auth += $db_auth;
+
+			if ($auth['authentication_type'] == ZBX_AUTH_LDAP
+					&& $auth['ldap_configured'] == ZBX_AUTH_LDAP_DISABLED) {
+				static::exception(ZBX_API_ERROR_PARAMETERS,
+					_s('Incorrect value for field "%1$s": %2$s.', '/authentication_type', _('LDAP must be enabled'))
+				);
+			}
+
+			$have_userdirectories = $auth['ldap_userdirectoryid'] != 0
+				|| API::UserDirectory()->get(['output' => ['userdirectoryid'], 'limit' => 1]);
+
+			if (!$have_userdirectories) {
+				static::exception(ZBX_API_ERROR_PARAMETERS,
+					_s('Incorrect value for field "%1$s": %2$s.', '/authentication_type', _('no LDAP servers'))
+				);
+			}
+		}
+
+		return $db_auth;
 	}
 }
diff --git a/ui/include/classes/api/services/CUser.php b/ui/include/classes/api/services/CUser.php
index 808f604d69e..ed999cbbec3 100644
--- a/ui/include/classes/api/services/CUser.php
+++ b/ui/include/classes/api/services/CUser.php
@@ -1380,54 +1380,6 @@ class CUser extends CApiService {
 		}
 	}
 
-	/**
-	 * Authenticate a user using LDAP.
-	 *
-	 * The $user array must have the following attributes:
-	 * - username   - user name
-	 * - password   - user password
-	 *
-	 * @param array $user
-	 *
-	 * @return bool
-	 */
-	protected function ldapLogin(array $user) {
-		$cnf = [];
-		$auth_params = [
-			CAuthenticationHelper::LDAP_CASE_SENSITIVE,
-			CAuthenticationHelper::LDAP_CONFIGURED,
-			CAuthenticationHelper::LDAP_HOST,
-			CAuthenticationHelper::LDAP_PORT,
-			CAuthenticationHelper::LDAP_BASE_DN,
-			CAuthenticationHelper::LDAP_BIND_DN,
-			CAuthenticationHelper::LDAP_SEARCH_ATTRIBUTE,
-			CAuthenticationHelper::LDAP_BIND_PASSWORD
-		];
-
-		foreach ($auth_params as $param) {
-			$cnf[str_replace('ldap_', '', $param)] = CAuthenticationHelper::get($param);
-		}
-
-		$ldap_status = (new CFrontendSetup())->checkPhpLdapModule();
-
-		if ($ldap_status['result'] != CFrontendSetup::CHECK_OK) {
-			self::exception(ZBX_API_ERROR_PARAMETERS, $ldap_status['error']);
-		}
-
-		$ldapValidator = new CLdapAuthValidator(['conf' => $cnf]);
-
-		if ($ldapValidator->validate($user)) {
-			return true;
-		}
-		else {
-			self::exception($ldapValidator->isConnectionError()
-					? ZBX_API_ERROR_PARAMETERS
-					: ZBX_API_ERROR_PERMISSIONS,
-				$ldapValidator->getError()
-			);
-		}
-	}
-
 	public function logout($user) {
 		$api_input_rules = ['type' => API_OBJECT, 'fields' => []];
 		if (!CApiInputValidator::validate($api_input_rules, $user, '/', $error)) {
@@ -1535,7 +1487,34 @@ class CUser extends CApiService {
 		try {
 			switch ($group_to_auth_map[$db_user['gui_access']]) {
 				case ZBX_AUTH_LDAP:
-					$this->ldapLogin($user);
+					if (CAuthenticationHelper::get(CAuthenticationHelper::LDAP_CONFIGURED) == ZBX_AUTH_LDAP_DISABLED) {
+						self::exception(ZBX_API_ERROR_INTERNAL, _('LDAP authentication is disabled.'));
+					}
+
+					$id = $db_user['userdirectoryid'] != 0
+						? $db_user['userdirectoryid']
+						: CAuthenticationHelper::get(CAuthenticationHelper::LDAP_USERDIRECTORYID);
+					$userdirectory = [];
+
+					if ($id != 0) {
+						$userdirectory = API::UserDirectory()->get([
+							'output' => ['userdirectoryid', 'host', 'port', 'base_dn', 'bind_dn', 'search_attribute',
+								'search_filter', 'start_tls'
+							],
+							'userdirectoryids' => $id
+						]);
+						$userdirectory = reset($userdirectory);
+					}
+
+					if (!$userdirectory) {
+						self::exception(ZBX_API_ERROR_INTERNAL, _('Cannot find user directory for LDAP.'));
+					}
+
+					$userdirectory += [
+						'test_username' => $user['username'],
+						'test_password' => $user['password']
+					];
+					API::UserDirectory()->test($userdirectory);
 					break;
 
 				case ZBX_AUTH_INTERNAL:
@@ -1548,7 +1527,6 @@ class CUser extends CApiService {
 
 				default:
 					self::exception(ZBX_API_ERROR_PERMISSIONS, _('No permissions for system access.'));
-					break;
 			}
 		}
 		catch (APIException $e) {
@@ -1809,25 +1787,65 @@ class CUser extends CApiService {
 		$permissions = [
 			'debug_mode' => GROUP_DEBUG_MODE_DISABLED,
 			'users_status' => GROUP_STATUS_ENABLED,
-			'gui_access' => GROUP_GUI_ACCESS_SYSTEM
+			'gui_access' => GROUP_GUI_ACCESS_SYSTEM,
+			'userdirectoryid' => 0
 		];
 
 		$db_usrgrps = DBselect(
-			'SELECT g.debug_mode,g.users_status,g.gui_access'.
+			'SELECT g.debug_mode,g.users_status,g.gui_access,g.userdirectoryid'.
 			' FROM usrgrp g,users_groups ug'.
 			' WHERE g.usrgrpid=ug.usrgrpid'.
 				' AND ug.userid='.$userid
 		);
 
+		$userdirectoryids = [];
+
 		while ($db_usrgrp = DBfetch($db_usrgrps)) {
 			if ($db_usrgrp['debug_mode'] == GROUP_DEBUG_MODE_ENABLED) {
 				$permissions['debug_mode'] = GROUP_DEBUG_MODE_ENABLED;
 			}
+
 			if ($db_usrgrp['users_status'] == GROUP_STATUS_DISABLED) {
 				$permissions['users_status'] = GROUP_STATUS_DISABLED;
 			}
+
 			if ($db_usrgrp['gui_access'] > $permissions['gui_access']) {
 				$permissions['gui_access'] = $db_usrgrp['gui_access'];
+				$userdirectoryids = [];
+			}
+
+			if ($permissions['gui_access'] === $db_usrgrp['gui_access']
+					&& ($db_usrgrp['gui_access'] == GROUP_GUI_ACCESS_LDAP
+						|| ($db_usrgrp['gui_access'] == GROUP_GUI_ACCESS_SYSTEM
+							&& CAuthenticationHelper::get(CAuthenticationHelper::AUTHENTICATION_TYPE) == ZBX_AUTH_LDAP
+			))) {
+				$userdirectoryids[$db_usrgrp['userdirectoryid']] = true;
+			}
+		}
+
+		if ($userdirectoryids) {
+			if (array_key_exists(0, $userdirectoryids)) {
+				unset($userdirectoryids[0]);
+				$default_userdirectoryid = CAuthenticationHelper::get(CAuthenticationHelper::LDAP_USERDIRECTORYID);
+
+				if ($default_userdirectoryid != 0) {
+					$userdirectoryids[$default_userdirectoryid] = true;
+				}
+			}
+
+			if (count($userdirectoryids) === 1) {
+				$permissions['userdirectoryid'] = array_keys($userdirectoryids)[0];
+			}
+			elseif (count($userdirectoryids) > 1) {
+				$db_userdirectoryids = API::UserDirectory()->get([
+					'output' => [],
+					'userdirectoryids' => array_keys($userdirectoryids),
+					'sortfield' => ['name'],
+					'limit' => 1,
+					'preservekeys' => true
+				]);
+
+				$permissions['userdirectoryid'] = array_keys($db_userdirectoryids)[0];
 			}
 		}
 
@@ -2062,6 +2080,7 @@ class CUser extends CApiService {
 	 * @param array  $permissions
 	 * @param string $permissions['debug_mode']
 	 * @param string $permissions['gui_access']
+	 * @param string $permissions['userdirectoryid']
 	 */
 	private function addExtraFields(array $db_user, array $permissions): array {
 		$db_user['type'] = $this->getUserType($db_user['roleid']);
@@ -2069,6 +2088,7 @@ class CUser extends CApiService {
 
 		$db_user['debug_mode'] = $permissions['debug_mode'];
 		$db_user['gui_access'] = $permissions['gui_access'];
+		$db_user['userdirectoryid'] = $permissions['userdirectoryid'];
 
 		if ($db_user['lang'] === LANG_DEFAULT) {
 			$db_user['lang'] = CSettingsHelper::getGlobal(CSettingsHelper::DEFAULT_LANG);
